(**
   Хȥåƥࡡץ륳
   ̱¦ɽԤץ

   @author Satoshi Ogasawara, IT Planning Inc.
   @version $Id: blist.ml,v 1.1 2007/05/23 03:51:19 ogasawara Exp $
*)
(*   
   Copyright (c) 2007 IT Planning inc. All Rights Reserved.

   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:
   
   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*)
open Printf
open Base
open Bug

(* ǽDB³ԤäƤ *)
let db = Db.connect ()
let _ = Gc.finalise Mysql.disconnect db

(* Υץबѥ᡼򵭽Ҥ⥸塼 *)
module Param = struct
  type t = { 
      search : string option; (* ʸ *)
      status : status list;   (* оݤȤХ *)
    }
	
  let search h = 
    try
      let v = h#param "search" in
      if v <> "" then Some v else None
    with
      _ -> None
	  
  let status h =
    List.concat
    @@ List.map (fun (status, key) -> 
      try 
	if h#param key <> "" then [status] else [] 
      with _ -> [])
    @@ List.combine status_list
    @@ List.map (sprintf "status%d" $ status2raw) status_list
	 
  (* CGIϥɥ餫 Param.tۤؿ *)      
  let parse handler = { search = search handler;
			status = status handler; }
      
end

(* Ϳ줿ˤäХbug.t listȤ֤ؿ.
   Τ Bug.list ˤΤǻȤΤ *)
let take param = 
  Bug.list db param.Param.search param.Param.status

(* bug.list鸡̤html tableʸ *)
let show_data_table = function
    [] -> "ǡϤޤ"
  | lst ->
      let show_row bug =
	sprintf 
	  ("<td><a href=\"/cgi-bin/body.cgi?id=%d\" target=\"body\">%s</a></td>" ^^
	   "<td>%s</td><td>%s</td>")
	  bug.id 
	  (if bug.title = "" then "(NO TITLE)" else bug.title)
	  (string_of_status bug.status)
	  (Calendar.to_string (List.hd bug.process).date)
      in
      string_of_list show_row ("<tr>", "</tr><tr>", "</tr>") lst

(* ƥץ졼Ȥإǡ *)	
let fill_template param =
  let templ = 
    CamlGI.Template.template Resource.list_template
  in
  templ#set "list" (show_data_table @@ take param);
  templ

(* ᥤؿ. CGIꥯȤParam.tѴơDBơƥץ졼Ȥ *)    
let main req =
  let cgi =
    new CamlGI.Cgi.cgi req
  in
  cgi#template
  @@ fill_template 
  @@ Param.parse cgi

let _ = 
  CamlGI.Cgi.register_script main
