(**
   Хȥåƥ ץ륳
   ̱¦ΰĤΥХ򰷤ץ
   
   $Id: body.ml,v 1.2 2007/05/23 03:57:16 ogasawara Exp $
*)
(*
   Copyright (c) 2007 ogasawara@itpl.co.jp All Rights Reserved.
   
   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:
  
   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,   
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*)
open Printf
open Base
open Bug

(* β̤ϤѤΥƥץ졼 *)
let fill_template_empty templ =
  templ#set "id" "";
  templ#set "body_id" "";
  templ#set "title" "";
  List.iter (fun x -> 
    templ#set (sprintf "status%d_checked" (status2raw x)) "") status_list;
  templ#set "comment" "";
  templ#set "days" "";
  templ

(* ǡΥƥץ졼 *)
let fill_template templ (bug, focus_process) =
  templ#set "id" (sprintf "%d" bug.id);
  let body_id =
    match focus_process with
      None -> ""
    | Some fp -> sprintf "%d" fp.body_id
  in
  templ#set "body_id" body_id;
  templ#set "title" bug.title;
  (* ХơǤ饸ܥ *)
  List.iter (fun x -> 
    let check =
      if bug.status = x then
	"checked"
      else
	""
    in
    templ#set (sprintf "status%d_checked" (status2raw x)) check) status_list;
  (* ʣΥȤʬ *)
  let fmt p date =
    match focus_process with
      Some fp when p <> fp -> 
	  sprintf "<tr><td><a href=\"body.cgi?id=%d&body_id=%d\">%s</a></td><td></td></tr>" 
	    bug.id p.body_id date
    | _ ->
	sprintf "<tr><td>%s</td><td></td></tr>" date
  in
  templ#set "days"
  @@ List.fold_left (^) ""
  @@ List.map (fun p -> fmt p @@ Calendar.to_string p.date) bug.process;
  let comment =
    match focus_process with
      Some fp ->
	fp.comment
    | None -> ""
  in
  (* ٤ɽ륳ȤϰĤ *)
  templ#set "comment" comment;
  templ
;;

open Body_param

(* DB³Ƥ *)
let db = Db.connect ()
let _ = Gc.finalise Mysql.disconnect db

(* ᥤؿ.
   CGIѥ᡼򸡺ưᡢ¹.
   ɽ٤ǡɽƽλ.
 *)
let main req =
  let cgi =
    new CamlGI.Cgi.cgi req
  in
  let param =
    Body_param.parse cgi
  in
  let to_display =
    match param.command with
      (* ڡʤ顢̵Ǻ *)
      NEW_PAGE ->
	let id, body_id =
	  Body_action.make_new_page db
	in
	Some (id, Some body_id)
    | _ ->
	match 
	  param.command, 
	  Bug.maybe_id db param.id
	with
	  NEW_BODY, Some id -> (* Ȥʤ顢idɬ *)
	    let body_id =
	      Body_action.make_new_body db id
	    in
	    Some (id, Some body_id)	  
	| DELETE_PAGE, Some id -> (* ڡʤ顢idɬ *)
	    Body_action.delete_page db id;
	    None
	| SAVE, Some id -> (* ֤ˤϡidɬ *)
	    let body_id =
	      Bug.maybe_body_id db param.body_id
	    in
	    Body_action.save db id body_id param;
	    Some (id, body_id)
	| _, Some id -> (* idñʤɽ *)
	    Some (id, Bug.maybe_body_id db param.body_id)
	| _ -> (* idʤжɽ *)
	    None
  in
  let templ = 
    CamlGI.Template.template Resource.body_template
  in
  (* ɽȥǡɽؤ *)
  match to_display with
    None ->
      cgi#template 
      @@ fill_template_empty templ
  | Some (id, body_id) ->
      cgi#template
      @@ fill_template templ
      @@ Bug.take db id body_id

let _ = 
  CamlGI.Cgi.register_script main
