(**
   Хȥåƥ ץ륳
   ʰ
   
   $Id: calendar.ml,v 1.1 2007/05/23 04:25:26 ogasawara Exp $
*)
(*
   Copyright (c) 2007 ogasawara@itpl.co.jp All Rights Reserved.
   
   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:
  
   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,   
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*)

open Unix

type t = Unix.tm

let today () =
  localtime (time ())

let compare d1 d2 =
  let clist = [ (d1.tm_year, d2.tm_year);
		(d1.tm_mon, d2.tm_mon);
		(d1.tm_mday, d2.tm_mday);
		(d1.tm_hour, d2.tm_hour);
		(d1.tm_min, d2.tm_min);
		(d1.tm_sec, d2.tm_sec); ]
  in
  let comp r (a, b) =
    if r = 0 then compare a b
    else r
  in
  List.fold_left comp 0 clist

let dsep = Str.regexp_string "-"

let of_string str = 
  let year :: month :: day :: [] = Str.split dsep str in
  { tm_sec = 0; 
    tm_min = 0; 
    tm_hour = 0;
    tm_mday = int_of_string day; 
    tm_mon = (int_of_string month) - 1; 
    tm_year = (int_of_string year) - 1900;
    tm_wday = 0; tm_yday = 0; tm_isdst = false; }

let year day =
  day.tm_year + 1900

let month day =
  day.tm_mon + 1

let to_string day = 
  Format.sprintf "%d-%d-%d"
    (year day)
    (month day)
    day.tm_mday
