(* daemon.ml 244-246p  *)
open Unix
open Event

(* äȤؿ *)
let (@@) f g = f g      (* Ŭ *)
let step f x = try f x with _ -> () (* 㳰֥å *)

(* ǡΩ夲ŻΥͥ㡼 *)
module type Work = sig
  type t
  val init : unit -> t
  val action : t * file_descr -> unit
end

(* ǡե󥯥. Ω夲Żѥ᡼˼ *)
module Daemon (W : Work) = struct
  let max_number_of_pending_request = 10

  (* ѤΥåȺ *)
  (* int -> Unix.file_descr *)
  let make_listener port = 
    let listen_socket = 
      (* internet domainTCP *)
      socket PF_INET SOCK_STREAM 0 
    in
    bind listen_socket @@ ADDR_INET (inet_addr_any, port);
    listen listen_socket max_number_of_pending_request;
    listen_socket

  (* ǡμ¹ *)
  (* int -> 'a *)
  let run port =
    let listener = make_listener port in
    let rec loop env =
      let fork (socket, _) =
        let wraped_action () =
          (step W.action) (env, socket);
          step (shutdown socket) SHUTDOWN_ALL;
          (step close) socket
        in
        ignore @@ Thread.create wraped_action ();
        loop env
      in
      (* ֤äơ³äfork *)
      fork (accept listener)
    in
    loop @@ W.init ()
end 

let _ =
  (* ե󥯥Ŭ *) 
  let module HelloDaemon = Daemon (struct 
    type t = unit
    let init () = ()
    (* ǡ󤬼¹Ԥư. ʸνϤ. *)
    let action (_, socket) =
      let out = out_channel_of_descr socket in
      output_string out "Hello. This is Daemon.\n";
      flush out
  end) in
  (* TCP8080ݡȤԵ *)
  HelloDaemon.run 8080
